<!doctype html>
{% load leaflet_tags %}
{% load static %}
<html>
  <head>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css">
    <link rel="stylesheet" href="{% static 'css/location.css' %}">
<header>

</header>
<body>
  <div class='container-fluid'>
    <div class='row'>
      <div class='col-2 card' id='sidebar'>
        <div class="card-body">

          <div class="form-group row">
            <div class="slidecontainer">
              <label for="distance" class="col-form-label"><b>DISTANCIA <span id="distanceValue"></span>m</label></b>
            
              <input type="range" min="100" max="2000" step="100" value="{{filters.distance}}" class="slider" id="distance">
            </div>
            
            </p>
          </div>

          <fieldset class="form-group">
            <div class="row">
              <legend class="col-form-label"> <b>LUGARES DE OCIO</b> </legend>
              <div class="col-sm-10">
                <div class="form-check">
                  {% if filters.restaurants %}
                  <input id="restaurants" type="checkbox" name="restaurants" checked>
                  {% else %}
                  <input id="restaurants" type="checkbox" name="restaurants">
                  {% endif %}                  
                  <label class="form-check-label" for="restaurants">
                  <b>Restaurantes <i class="fas fa-pizza-slice" style="color: #1030AD"></i></b>
                  </label>
                </div>
                <div class="form-check">
                  {% if filters.terrace %}
                  <input id="terrace" type="checkbox" name="terrace" checked>
                  {% else %}
                  <input id="terrace" type="checkbox" name="terrace">
                  {% endif %}                  <label class="form-check-label" for="terrace">
                    <b>Terrazas  <i class="fas fa-wine-glass-alt" style="color: #333333"></i></b>
                  </label>
                </div>
                <div class="form-check">
                  {% if filters.parks %}
                  <input id="parks" type="checkbox" name="parks" checked>
                  {% else %}
                  <input id="parks" type="checkbox" name="parks">
                  {% endif %}
                  <label class="form-check-label" for="parks">
                    <b>Parques <i class="fa fa-tree" style="color: #3B8076"></i></b>
                  </label> 
                </div>
                <div class="form-check">
                  {% if filters.cinema %}
                  <input id="cinema" type="checkbox" name="cinema" checked>
                  {% else %}
                  <input id="cinema" type="checkbox" name="cinema">
                  {% endif %}                  <label class="form-check-label" for="cinema">
                    <b>Cines  <i class="fas fa-ticket-alt" style="color: #cc68e2"></i></b>
                  </label>
                </div>
                <div class="form-check">
                  {% if filters.theater %}
                  <input id="theater" type="checkbox" name="theater" checked>
                  {% else %}
                  <input id="theater" type="checkbox" name="theater">
                  {% endif %}                  <label class="form-check-label" for="theater">
                    <b>Teatros  <i class="fas fa-theater-masks" style="color: #6A0DAD"></i></b>
                  </label>
                </div>
              </div>
            </div>
          </fieldset>
          <fieldset class="form-group">
            <div class="row">
              <legend class="col-form-label"><b>IMPACTO COVID</b></legend>
              <div class="col-sm-10">
                  <i class="fas fa-circle" style="font-size: 20px; color: green;"></i> Zona Incidencia Baja </br>
                  <i class="fas fa-circle" style="font-size: 20px; color: yellow;"></i> Zona Incidencia Media</br>
                  <i class="fas fa-circle" style="font-size: 20px; color: orange;"></i> Zona Incidencia Alta</br>
                  <i class="fas fa-circle" style="font-size: 20px; color: red;"></i> Zona Restringida</br>
              </div>
            </div>
          </fieldset>
          <button type="button" class="btn btn-primary" id="locateMe">Ir a mi Localización <i class="fa fa-location-arrow"></i></button>
        </div>
      </div>
      <div id='mapContainer'>
        {% block content %}
        {% endblock %}
        {% leaflet_map "main" callback="window.map_init_basic" %}
      </div>
    </div>
  </div>
</body>

    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
      {% leaflet_js %}
    {% leaflet_css %}    

    <script>
      const baseUrl = 'http://localhost:8000'
      const latLongEndpoint = ` ${baseUrl}/search`

      function redirectUserLoc(position) {
        
        lat = position.coords.latitude
        lng = position.coords.longitude
        const distance = $('#distance').val()
        const parkscheckbox = document.getElementById('parks').checked
        const restaurantscheckbox = document.getElementById('restaurants').checked
        const terracecheckbox = document.getElementById('terrace').checked
        const cinemacheckbox = document.getElementById('cinema').checked
        const theatercheckbox = document.getElementById('theater').checked

        console.log("User coords", lat, lng, distance)
                  const latLngUrl = `${latLongEndpoint}?lat=${lat}&lng=${lng}&distance=${distance}&parks=${parkscheckbox}&restaurants=${restaurantscheckbox}&terrace=${terracecheckbox}&cinema=${cinemacheckbox}&theater=${theatercheckbox}`
        window.location.href = latLngUrl;
      }

      function onRedirect (lat, lng) {
          const distance = $('#distance').val()
          const parkscheckbox = document.getElementById('parks').checked
          const restaurantscheckbox = document.getElementById('restaurants').checked
          const terracecheckbox = document.getElementById('terrace').checked
          const cinemacheckbox = document.getElementById('cinema').checked
          const theatercheckbox = document.getElementById('theater').checked

          const latLngUrl = `${latLongEndpoint}?lat=${lat}&lng=${lng}&distance=${distance}&parks=${parkscheckbox}&restaurants=${restaurantscheckbox}&terrace=${terracecheckbox}&cinema=${cinemacheckbox}&theater=${theatercheckbox}`
          window.location.href = latLngUrl;
      }

      var barIcon = L.icon({
        iconUrl: 'static/files/wine.svg',
        iconSize:     [20, 25], // size of the icon
        shadowSize:   [0, 0], // size of the shadow
        iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
        shadowAnchor: [0, 0],  // the same for the shadow
        popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
      });
      var restaurantIcon = L.icon({
        iconUrl: 'static/files/pizza.svg',
        iconSize:     [20, 25], // size of the icon
        shadowSize:   [0, 0], // size of the shadow
        iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
        shadowAnchor: [0, 0],  // the same for the shadow
        popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
      });
      var parkIcon = L.icon({
        iconUrl: 'static/files/tree.svg',
        iconSize:     [20, 25], // size of the icon
        shadowSize:   [0, 0], // size of the shadow
        iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
        shadowAnchor: [0, 0],  // the same for the shadow
        popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
      });
      var cinemaIcon = L.icon({
        iconUrl: 'static/files/ticket.svg',
        iconSize:     [20, 25], // size of the icon
        shadowSize:   [0, 0], // size of the shadow
        iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
        shadowAnchor: [0, 0],  // the same for the shadow
        popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
      });
       var theaterIcon = L.icon({
        iconUrl: 'static/files/masks.svg',
        iconSize:     [20, 25], // size of the icon
        shadowSize:   [0, 0], // size of the shadow
        iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
        shadowAnchor: [0, 0],  // the same for the shadow
        popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
      });

      $( document ).ready(function() {
          {% if init_lat != None and init_long != None %}
            console.log("Coords defined", {{init_lat}}, {{init_long}})
          {% else %}
            console.log("Coords not defined")
          {% endif %}

          $("#locateMe").click(function(){
            navigator.geolocation.getCurrentPosition(redirectUserLoc)
          })
          var slider = document.getElementById("distance");
          var output = document.getElementById("distanceValue");
          output.innerHTML = slider.value; // Display the default slider value

          // Update the current slider value (each time you drag the slider handle)
          slider.oninput = function() {
            output.innerHTML = this.value;
          }
      });

      function map_init_basic (map, options) {
        map.on('click', function(e) {
            const {lat, lng} = e.latlng
            onRedirect(lat, lng)
        });
        map.setZoom(15)


        {% if init_lat != None and init_long != None%}
          {% for infl_area_jinja in infl_areas %}
            var infl_area = {{ infl_area_jinja|safe }};
            
            if (infl_area.restricted_area == 1) {
              color = 'red'
            } else if (infl_area.covid_impact == 1) {
              color = 'green'
            } else if (infl_area.covid_impact == 2) {
              color = 'yellow'
            } else if (infl_area.covid_impact == 3) {
              color = 'orange'
            }

            console.log(color, infl_area.cut_area)
            var polygon = L.polygon(infl_area.cut_area, {color: color});
            polygon.addTo(map);

            for (i in infl_area.pois) {
              var poi = infl_area.pois[i]
              var icon = barIcon
              var poi_type = 'terraza'
              if (poi.type == 'restauracion') {
                if (poi.features.max_capacity) {
                  icon = barIcon
                  poi_type = 'Terraza'
                } else {
                  icon = restaurantIcon
                  poi_type = 'Restaurante'
                }
              } else if (poi.type == 'cines') {
                icon = cinemaIcon
                poi_type = 'Cine'
              } else if (poi.type == 'teatros') {
                icon = theaterIcon
                poi_type = 'Teatro'
              } else if (poi.type == 'parques_jardines') {
                icon = parkIcon
                poi_type = 'Parques y Jardines'
              }
              // create popup contents
              var customPopup = "<span class='poiName'>" + poi.name + "</span><br/>" + "<span class='poiType'>" + poi_type + "</span><br/><span class='poiAddress'>" + poi.address + '</span></br><br/><br/><span class="subtext">¿Cumple las medidas COVID?</span> <i class="fas fa-thumbs-up collaborative" style="color: green"></i>    <i class="fas fa-thumbs-down collaborative" style="color: red"></i>';
              
              // specify popup options 
              var customOptions =
                  {
                  'maxWidth': '500',
                  'className' : 'custom'
                  }
              var marker = L.marker([poi.lng, poi.lat], {icon: icon}).addTo(map);
              marker.bindPopup(customPopup)
            }

          {% endfor %}
          L.marker([{{init_lat}}, {{init_long}}]).addTo(map);
          map.fitBounds(polygon.getBounds());
          map.setView(new L.LatLng({{init_lat}}, {{init_long}}), 16)

          // var radio_area = {{ radio_area|safe }};
          // var polygon = L.polygon(radio_area, {color: 'orange'});
          // polygon.addTo(map);
          // map.fitBounds(polygon.getBounds());
        {% endif %}
      }

    </script>
</html>
